var isRunning = false;
var isFinished = false;
var setMin = parseInt(preferences.timerMinutes.value);
var setSec = parseInt(preferences.timerSeconds.value);
var curMin = setMin;
var curSec = setSec;
var dock = false;
var dockTime;
var dockBackground;

function createDock()
{
	if (!widget.dockOpen) { return; }

	var doc = XMLDOM.createDocument();
	var v = doc.createElement("dock-item");
	v.setAttribute("version","1.0");
	doc.appendChild(v);

	dockBackground = doc.createElement("image");
	dockBackground.setAttribute("src","Resources/dockBackground.png");
	dockBackground.setAttribute("hOffset",0);
	v.appendChild(dockBackground);
	
	dockTime = doc.createElement("text");
	dockTime.setAttribute("hOffset","38");
	dockTime.setAttribute("vOffset","42");
	dockTime.setAttribute("hAlign","center");
	dockTime.setAttribute("style","font-family: Arial;font-size: 24px; font-weight: bold; color: white;");
	dockTime.setAttribute("data","foo");
	v.appendChild(dockTime);
	
	return doc;
}

function updateDock() {
	if (!dock) dock = createDock();
	if (isFinished)
		dockBackground.setAttribute("colorize", preferences.finishedColor.value);
	else if (isRunning)
		dockBackground.setAttribute("colorize", preferences.runningColor.value);
	else
		dockBackground.setAttribute("colorize", preferences.defaultColor.value);
	dockTime.setAttribute("data", formatTime(curMin,curSec));
	widget.setDockItem(dock, "fade");	
}



function toggleTimer() {
	if (isFinished) {
		isFinished = false;
		resetTimer();
	}
	else if (isRunning) {
		stopTimer();
	}
	else {
		startTimer();
	}
	updateDisplay();
}

function startTimer() {
	isRunning = true;
	secondsTimer.ticking = isRunning;
	secondsTimer.reset();
}

function stopTimer() {
	isRunning = false;
	secondsTimer.ticking = isRunning;
}

function setTimer(mins, secs) {
	curMin = mins;
	curSec = (secs == undefined ? 0 : secs);
	updateDisplay();
}

function resetTimer() {
	isFinished = false;
	setTimer(setMin, setSec);
}

function setAlarm(mins,secs) {
	setMin = mins > 99 ? 0 : mins < 0 ? 99 : mins;
	setSec = secs > 59 ? 0 : secs < 0 ? 59 : secs;
	preferences.timerMinutes.value = setMin;
	preferences.timerSeconds.value = setSec;
	updateDisplay();
}

function formatTime(min,sec) {
	timeStr = (min == 0) ? "00" : (min >= 10) ? min.toString() : "0" + min.toString();
	timeStr += ":";
	timeStr += (sec == 0) ? "00" : (sec >= 10) ? sec.toString() : "0" + sec.toString();
	return timeStr;
}

function updateDisplay() {
	timer.data = formatTime(curMin,curSec);
	timerSetting.data = formatTime(setMin,setSec);
	glowingBackground.visible = isFinished;
	runningBackground.visible = isRunning;
	updateDock();
}

function updateColors() {
	glowingBackground.colorize = preferences.finishedColor.value;
	background.colorize = preferences.defaultColor.value;
	runningBackground.colorize = preferences.runningColor.value;
	updateDock();
}

function playAlarm() {
	if (preferences.usesound.value == 1) play("Resources/beep.wav");
}

function timerFired() {
	if (curMin == 0 && curSec <= 1) {
		stopTimer();
		playAlarm();
		isFinished = true;
		setTimer(0, 0);
	}
	else if (curSec == 0) {
		setTimer(curMin-1, 59);
	}
	else {
		setTimer(curMin, curSec-1);
	}
}

updateColors();
updateDisplay();
mainWindow.visible = true;
